#include <QToolBar>
#include <QMessageBox>
#include <QCloseEvent>
#include <QDebug>
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "glwidget.h"

MainWindow::~MainWindow() {
    delete ui;
}

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    red = green = blue = 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// autoconnect callback functions

void MainWindow::on_xRotSlider_valueChanged(int value) {
    ui->xRotSpin->setValue(value);
    ui->glwidget->setXRot(value);
}

void MainWindow::on_yRotSlider_valueChanged(int value) {
    ui->yRotSpin->setValue(value);
    ui->glwidget->setYRot(value);
}

void MainWindow::on_zRotSlider_valueChanged(int value) {
    ui->zRotSpin->setValue(value);
    ui->glwidget->setZRot(value);
}

void MainWindow::on_xRotSpin_valueChanged(int value) {
    ui->xRotSlider->setValue(value);
    ui->glwidget->setXRot(value);
}

void MainWindow::on_yRotSpin_valueChanged(int value) {
    ui->yRotSlider->setValue(value);
    ui->glwidget->setYRot(value);
}

void MainWindow::on_zRotSpin_valueChanged(int value) {
    ui->zRotSlider->setValue(value);
    ui->glwidget->setZRot(value);
}

void MainWindow::on_redSlider_valueChanged(int value) {
    red = value/100.;
    ui->redSpin->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::on_greenSlider_valueChanged(int value) {
    green = value/100.;
    ui->greenSpin->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::on_blueSlider_valueChanged(int value) {
    blue = value/100.;
    ui->blueSpin->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::on_redSpin_valueChanged(int value) {
    red = value/100.;
    ui->redSlider->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::on_greenSpin_valueChanged(int value) {
    green = value/100.;
    ui->greenSlider->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::on_blueSpin_valueChanged(int value) {
    blue = value/100.;
    ui->blueSlider->setValue(value);
    ui->glwidget->setColor(red, green, blue);
}

void MainWindow::closeEvent(QCloseEvent *e) {
  e->ignore();
  quitApp();
}

void MainWindow::quitApp() {
  int ret = QMessageBox::critical(this,
                                  tr("Quit Application"),
                                  tr("Do you want to quit?"),
                                  QMessageBox::Yes | QMessageBox::No);
  if (ret == QMessageBox::Yes) QApplication::quit();
}
